package message;

/**
 * This class represents a simple message printer.
 * It prints a given message a specified number of times.
 */
public class Message {
    // Instance variables to hold the message text and number of times to print
    private String msg;
    private int times;

    /**
     * Constructor to initialize the message and repetition count.
     *
     * @param msg   the message to print
     * @param times how many times to print the message
     */
    public Message(String msg, int times) {
        this.msg = msg;
        this.times = times;
    }

    /**
     * This method prints the message 'times' times.
     * It's a simple loop — and in a single-threaded program,
     * this method must finish entirely before anything else continues.
     */
    public void print() {
        for (int i = 0; i < times; i++) {
            System.out.println(msg);
        }
    }
}
