package messageThreadExtends;


/**
 * This class demonstrates multithreaded execution using the Thread class.
 * It creates two threads that print messages concurrently.
 */

//Run the driver several times to see the changes in output.  
//Notice than main thread will finish at different times

public class Driver {
    public static void main(String[] args) {
        // Number of times each message should be printed
        int times = 1000;

        // Create two MessageThread objects, each with its own message
        MessageThread msg1 = new MessageThread("Hello", times);
        MessageThread msg2 = new MessageThread("Bienvenidos", times);

        // Start both threads
        // msg1 and msg2 will now execute concurrently (interleaved output is possible)
        msg1.start();
        msg2.start();

        // This message may print before, during, or after msg1 and msg2 finish
        // because all three are running concurrently
        System.out.println("Driver done");
    }
}
