package messageThreadExtends;

/**
 * This class demonstrates multithreading using the Thread class.
 * Each instance of MessageThread runs its task (printing a message) in its own thread.
 */
public class MessageThread extends Thread {
    // Message to print and how many times
    private String msg;
    private int times;

    /**
     * Constructor to initialize the message and repetition count.
     *
     * @param msg   the message to print
     * @param times how many times to print the message
     */
    public MessageThread(String msg, int times) {
        this.msg = msg;
        this.times = times;
    }

    /**
     * The run() method defines the work to be done in the thread.
     * Java will execute this in a separate thread when start() is called.
     * Note: run() should not be called directly — use start() instead.
     */
    public void run() {
        for (int i = 0; i < times; i++) {
            System.out.println(msg);
        }
    }

    // Note: we could have moved this loop into a separate method like print()
    // and called print() inside run(), but the current version is simpler
}

