package messageThreadExtends;
// Import necessary Java packages
public class MyThreadExample extends Thread {

    // Override the run() method to define what the thread will do
    @Override
    public void run() {
        // Code inside run() is the task that the thread will perform
        // This code will run in parallel with the main thread
        System.out.println("Thread is now running! Task starts.");
        
        // Simulating some work (e.g., processing something)
        try {
            Thread.sleep(2000);  // Makes the thread "sleep" for 2 seconds (simulating work)
            System.out.println("Task finished after 2 seconds.");
        } catch (InterruptedException e) {
            System.out.println("Thread was interrupted.");
        }
    }

    public static void main(String[] args) {
        // Create a new thread by creating an instance of the MyThreadExample class
        MyThreadExample thread1 = new MyThreadExample();
        
        // Start the thread by calling start() — this invokes the run() method in parallel
        thread1.start();

        // Main thread continues executing independently of the new thread
        System.out.println("Main thread continues to run while the new thread works.");

        try {
            // Main thread waits for thread1 to finish before proceeding (this is optional)
            thread1.join(); // Waits until thread1 has completed its task
            System.out.println("Main thread finished after waiting for the new thread.");
        } catch (InterruptedException e) {
            System.out.println("Main thread was interrupted.");
        }
    }
}

