package messageThreadRunnable;


/**
 * Demonstrates how to create and run multiple threads using the Runnable interface.
 * Also shows how to use a lambda expression to define a quick Runnable on the fly.
 */
public class Driver {
    public static void main(String[] args) {
        int times = 1000;

        // Create a Runnable task that prints "Hello" 1000 times
        DisplayMessageTask msg1Task = new DisplayMessageTask("Hello", times);
        // Wrap the Runnable in a Thread object
        Thread msg1Tread = new Thread(msg1Task);

        // Create another Runnable task that prints "Bienvenidos" 1000 times
        DisplayMessageTask msg2Task = new DisplayMessageTask("Bienvenidos", times);
        Thread msg2Thread = new Thread(msg2Task);

        // Create a thread using a lambda expression that prints "Hola" 100 times
        Thread msg3Thread = new Thread(() -> {
            for (int i = 1; i <= 100; i++) {
                System.out.println("Hola");
            }
        });

        // Start all three threads — they will run concurrently
        msg1Tread.start();
        msg2Thread.start();
        msg3Thread.start();

        // This message prints from the main thread
        System.out.println("Driver done");
    }
}
